diff --git a/core/src/aos_sssp.c b/core/src/aos_sssp.c
index 8f82143..90ceab1 100644
--- a/core/src/aos_sssp.c
+++ b/core/src/aos_sssp.c
@@ -83,18 +83,19 @@ static float _syncskew;
 
 /**
  * @brief   A timer event based delays.
+ * @details This timer must not be an AMiRo-OS timer, since delays occurr before system is initialized.
  */
 static virtual_timer_t _delayTimer;
 
 /**
  * @brief   Event source for the delay timer.
  */
-static event_source_t _eventSourceDelay;
+static event_source_t _delayEventSource;
 
 /**
  * @brief   Event listener for the delay event.
  */
-static event_listener_t _eventListenerDelay;
+static event_listener_t _delayEventListener;
 
 /******************************************************************************/
 /* LOCAL FUNCTIONS                                                            */
@@ -103,7 +104,7 @@ static event_listener_t _eventListenerDelay;
 #if (AMIROOS_CFG_SSSP_MASTER != true) || defined(__DOXYGEN__)
 
 /**
- * @brief   Callback function for the Sync signal interrupt.
+ * @brief   Callback function for the S signal interrupt.
  *
  * @param[in] args   Pointer to the GPIO line identifier.
  */
@@ -119,7 +120,7 @@ static void _gpioCallbackSSignal(void *args)
   // if the system is in operation phase
   if (aos.sssp.stage == AOS_SSSP_STAGE_OPERATION) {
     // read signal S
-    apalControlGpioGet(&moduleSsspGpioS, &s);
+    apalControlGpioGet(moduleSsspSignalS(), &s);
     // if S was toggled from on to off
     if (s == APAL_GPIO_OFF) {
       // get current uptime
@@ -154,7 +155,7 @@ static void _gpioCallbackSSignal(void *args)
 
 /**
  * @brief   Periodic system synchronization callback function.
- * @details Toggles the SYS_SYNC signal and reconfigures the system synchronization timer.
+ * @details Toggles the S signal and reconfigures the system synchronization timer.
  *
  * @param[in] par   Unused parameters.
  */
@@ -162,19 +163,20 @@ static void _syncTimerCallback(void* par)
 {
   (void)par;
 
+  // local variables
   apalControlGpioState_t state;
   aos_timestamp_t uptime;
 
   chSysLockFromISR();
   // toggle and read signal S
-  apalGpioToggle(moduleSsspGpioS.gpio);
-  apalControlGpioGet(&moduleSsspGpioS, &state);
+  apalGpioToggle(moduleSsspSignalS()->gpio);
+  apalControlGpioGet(moduleSsspSignalS(), &state);
   // if S was toggled from off to on
   if (state == APAL_GPIO_ON) {
     // reconfigure the timer precisely, because the logically falling edge (next interrupt) snychronizes the system time
     _synctime += AMIROOS_CFG_SSSP_SYSSYNCPERIOD;
     aosSysGetUptimeX(&uptime);
-    chVTSetI(&_synctimer, chTimeUS2I(_synctime - uptime), _syncTimerCallback, NULL);
+    chVTSetI(&_synctimer, chTimeUS2I((time_usecs_t)(_synctime - uptime)), _syncTimerCallback, NULL);
   }
   // if S was toggled from on to off
   else /* if (state == APAL_GPIO_OFF) */ {
@@ -199,7 +201,7 @@ static inline void _syncTimerStartS(void)
   aos_timestamp_t t;
   aosSysGetUptimeX(&t);
   t = AMIROOS_CFG_SSSP_SYSSYNCPERIOD - (t % AMIROOS_CFG_SSSP_SYSSYNCPERIOD);
-  chVTSetI(&_synctimer, chTimeUS2I((t > (AMIROOS_CFG_SSSP_SYSSYNCPERIOD / 2)) ? (t - (AMIROOS_CFG_SSSP_SYSSYNCPERIOD / 2)) : (t + (AMIROOS_CFG_SSSP_SYSSYNCPERIOD / 2))), _syncTimerCallback, NULL);
+  chVTSetI(&_synctimer, chTimeUS2I((time_usecs_t)((t > (AMIROOS_CFG_SSSP_SYSSYNCPERIOD / 2)) ? (t - (AMIROOS_CFG_SSSP_SYSSYNCPERIOD / 2)) : (t + (AMIROOS_CFG_SSSP_SYSSYNCPERIOD / 2)))), _syncTimerCallback, NULL);
 
   return;
 }
@@ -226,33 +228,41 @@ static void _timerCallback(void* par)
  * @brief   Waits for the S signal to switch to the desired state.
  *
  * @param[in]   listener      Pointer to the GPIO event listener to be used.
- * @param[in]   flags         Event flags to listen to by the event listener (indicating a S signal event).
  * @param[in]   signalstate   Desired state of the S signal ti be waited for.
  * @param[out]  received      Output variable to store the received event mask to.
  *
  * @return  Status, indicating whether the expected event was received.
  */
-static inline aos_status_t _waitForS(event_listener_t* listener, eventflags_t flags, apalControlGpioState_t signalstate, eventmask_t* received)
+static inline aos_status_t _waitForS(event_listener_t* listener, apalControlGpioState_t signalstate, eventmask_t* received)
 {
   aosDbgCheck(listener != NULL);
-  aosDbgCheck(flags != 0);
   aosDbgCheck(received != NULL);
 
+  // local variables
+  aos_status_t status = AOS_FAILURE;
+
   // wait for the next event (do not apply any filters in order not to miss any events)
   *received = chEvtWaitOne(ALL_EVENTS);
   // if the correct event was triggered
-  if (*received == listener->events) {
+  if (*received & listener->events) {
     apalControlGpioState_t s;
-    apalControlGpioGet(&moduleSsspGpioS, &s);
+    apalControlGpioGet(moduleSsspSignalS(), &s);
+    chSysLock();
     // only check for the expected event
-    if (flags & listener->flags && s == signalstate) {
+    if ((listener->flags & moduleSsspEventflagS()) && (s == signalstate)) {
       // unset the expected flags but keep any other ones
-      listener->flags &= ~flags;
-      return AOS_SUCCESS;
+      listener->flags &= ~moduleSsspEventflagS();
+      status = AOS_SUCCESS;
     }
+    // if no further flags are set
+    if (listener->flags == 0) {
+      // clear event
+      *received &= ~(listener->events);
+    }
+    chSysUnlock();
   }
 
-  return AOS_FAILURE;
+  return status;
 }
 
 /**
@@ -260,35 +270,159 @@ static inline aos_status_t _waitForS(event_listener_t* listener, eventflags_t fl
  *
  * @param[in]   dt          Delay time in microseconds to be set to the timer.
  * @param[in]   mask        Event mask to be used for the delay timer.
- * @param[in]   arm_timer   Flag to indicate whether the timer has to be armed yet (i.e. on first call of this function).
  * @param[out]  received    Output variable to store the received event mask to.
  *
  * @return  Status, indicating whether the expected event (delay timer) was received.
  */
-static inline aos_status_t _delay(uint32_t dt, eventmask_t mask, bool arm_timer, eventmask_t* received)
+static inline aos_status_t _delay(uint32_t dt, eventmask_t mask, eventmask_t* received)
 {
   aosDbgCheck(dt != TIME_IMMEDIATE);
   aosDbgCheck(mask != 0);
   aosDbgCheck(received != NULL);
 
   // arm the delay timer once
-  if (arm_timer) {
-    chEvtRegisterMask(&_eventSourceDelay, &_eventListenerDelay, mask);
-    chVTSet(&_delayTimer, chTimeUS2I(dt), _timerCallback, &_eventSourceDelay);
+  if (!chVTIsArmed(&_delayTimer)) {
+    chEvtRegisterMask(&_delayEventSource, &_delayEventListener, mask);
+    chVTSet(&_delayTimer, chTimeUS2I(dt), _timerCallback, &_delayEventSource);
   }
 
   // wait for any event to occur (do not apply any filters in order not to miss any events)
   *received = chEvtWaitOne(ALL_EVENTS);
 
   // if the timer event was received, cleanup
-  if (*received & _eventListenerDelay.events) {
-    chEvtUnregister(&_eventSourceDelay, &_eventListenerDelay);
+  if (*received & _delayEventListener.events) {
+    chEvtUnregister(&_delayEventSource, &_delayEventListener);
+    *received &= ~(_delayEventListener.events);
     return AOS_SUCCESS;
   }
 
   return AOS_FAILURE;
 }
 
+#if (AMIROOS_CFG_SSSP_MSI == true) || defined(__DOXYGEN__)
+
+/**
+ * @brief   Serialize a BCB message.
+ * @details The individual primitives are serialized in big-endian fashion.
+ *
+ * @param[out]  buffer    Buffer to write the serialized message to.
+ * @param[in]   message   The message to be serialized.
+ */
+aos_status_t _serializeBcbMessage(uint8_t* buffer, aos_ssspbcbmessage_t message)
+{
+  aosDbgCheck(buffer != NULL);
+
+  // encode the message depending on its type
+  switch (message.type) {
+    case AOS_SSSP_BCBMESSAGE_MSIINIT:
+    case AOS_SSSP_BCBMESSAGE_MSIABORT:
+    {
+      buffer[0] = message.type;
+      return AOS_SUCCESS;
+    }
+    case AOS_SSSP_BCBMESSAGE_MSIID:
+    {
+      buffer[0] = message.type;
+      for (size_t byte = 0; byte < sizeof(aos_ssspmoduleid_t); ++byte) {
+        buffer[byte+1] = (message.payload.id >> (8 * (sizeof(aos_ssspmoduleid_t) - (byte+1)))) & 0xFF;
+      }
+      return AOS_SUCCESS;
+    }
+    default:
+    {
+      return AOS_FAILURE;
+    }
+  }
+}
+
+/**
+ * @brief   Deserialize a BCB message.
+ * @details The individual primitives must be serialized in big-endian fashion.
+ *
+ * @param[out]  message   Message object to be filled.
+ * @param[in]   buffer    Buffer holding the serialized message.
+ */
+aos_status_t _deserializeBcbMessage(aos_ssspbcbmessage_t* message, uint8_t* buffer)
+{
+  aosDbgCheck(message != NULL);
+  aosDbgCheck(buffer != NULL);
+
+  // only decode the first byte, which contains the message type
+  message->type = buffer[0];
+
+  // decode the message depedning on its type
+  switch (message->type) {
+    case AOS_SSSP_BCBMESSAGE_MSIINIT:
+    case AOS_SSSP_BCBMESSAGE_MSIABORT:
+    {
+      return AOS_SUCCESS;
+    }
+    case AOS_SSSP_BCBMESSAGE_MSIID:
+    {
+      message->payload.id = 0;
+      for (size_t byte = 0; byte < sizeof(aos_ssspmoduleid_t); ++byte) {
+        message->payload.id |= (aos_ssspmoduleid_t)(buffer[byte+1] << (8 * (sizeof(aos_ssspmoduleid_t) - (byte+1))));
+      }
+      return AOS_SUCCESS;
+    }
+    default:
+    {
+      message->type = AOS_SSSP_BCBMESSAGE_INVALID;
+      return AOS_FAILURE;
+    }
+  }
+}
+
+/**
+ * @brief   Common outro of the module stack initialization (MSI).
+ * @details This function must be called on failure, success and if MSI is skipped.
+ *
+ * @param[in] msidata   Pointer to the temporary data structure used during MSI.
+ */
+void _msiOutro(aos_ssspmsidata_t* msidata)
+{
+  aosDbgCheck(msidata != NULL);
+
+  // local variables
+  eventmask_t mask = 0;
+
+  // start the internal uptime aggregation
+  chSysLock();
+  aosSysStartUptimeS();
+#if (AMIROOS_CFG_SSSP_MASTER == true)
+  // start toggling S for system synchronization
+  _syncTimerStartS();
+#endif /* (AMIROOS_CFG_SSSP_MASTER == true) */
+  chSysUnlock();
+
+  // reset delay timer
+  chVTIsArmed(&_delayTimer);
+  // unregister delay events
+  mask |= _delayEventListener.events;
+  chEvtUnregister(&_delayEventSource, &_delayEventListener);
+
+#if (AMIROOS_CFG_SSSP_STACK_END != true)
+  // deactivate UP signal
+  apalControlGpioSet(moduleSsspSignalUP(), APAL_GPIO_OFF);
+#endif /* (AMIROOS_CFG_SSSP_STACK_END != true) */
+
+  // reset timeout timer
+  chVTReset(&msidata->timeout.timer);
+  // unregister timeout events
+  mask |= msidata->timeout.eventlistener.events;
+  chEvtUnregister(&msidata->timeout.eventsource, &msidata->timeout.eventlistener);
+
+  // discard any pending timing events
+  chEvtWaitAnyTimeout(mask, TIME_IMMEDIATE);
+
+  // proceed to operation phase
+  aos.sssp.stage = AOS_SSSP_STAGE_OPERATION;
+
+  return;
+}
+
+#endif /* (AMIROOS_CFG_SSSP_MSI == true) */
+
 /******************************************************************************/
 /* EXPORTED FUNCTIONS                                                         */
 /******************************************************************************/
@@ -300,9 +434,6 @@ void aosSsspInit(aos_timestamp_t* system_uptime)
 {
   aosDbgCheck(system_uptime != NULL);
 
-  // local variables
-  apalControlGpioState_t state;
-
 #if (AMIROOS_CFG_SSSP_STARTUP == true)
   // AMiRo-OS has to perform the basic initialization
   aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_1_1;
@@ -311,26 +442,29 @@ void aosSsspInit(aos_timestamp_t* system_uptime)
   aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_2_1;
 #endif /* (AMIROOS_CFG_SSSP_STARTUP == true) */
 
+  // module ID is initialized as 'invalid'
+  aos.sssp.moduleId = AOS_SSSP_MODULEID_INVALID;
+
+#if (AMIROOS_CFG_DBG == true)
   // check all SSSP signals for correct state
-  apalControlGpioGet(&moduleSsspGpioS, &state);
-  aosDbgAssert(state == APAL_GPIO_ON);
-  apalControlGpioGet(&moduleSsspGpioPD, &state);
-  aosDbgAssert(state == APAL_GPIO_OFF);
+  {
+    apalControlGpioState_t state;
+    apalControlGpioGet(moduleSsspSignalS(), &state);
+    aosDbgAssert(state == APAL_GPIO_ON);
+    apalControlGpioGet(moduleSsspSignalPD(), &state);
+    aosDbgAssert(state == APAL_GPIO_OFF);
 #if (AMIROOS_CFG_SSSP_MSI == true)
-#if (AMIROOS_CFG_SSSP_STACK_END != true)
-  apalControlGpioGet(&moduleSsspGpioUP, &state);
-  aosDbgAssert(state == APAL_GPIO_OFF);
-#endif /* (AMIROOS_CFG_SSSP_STACK_END != true) */
 #if (AMIROOS_CFG_SSSP_STACK_START != true)
-  apalControlGpioGet(&moduleSsspGpioDN, &state);
-  aosDbgAssert(state == APAL_GPIO_OFF);
+    apalControlGpioGet(moduleSsspSignalDN(), &state);
+    aosDbgAssert(state == APAL_GPIO_OFF);
 #endif /* (AMIROOS_CFG_SSSP_STACK_START != true) */
+#if (AMIROOS_CFG_SSSP_STACK_END != true)
+    apalControlGpioGet(moduleSsspSignalUP(), &state);
+    aosDbgAssert(state == APAL_GPIO_OFF);
+#endif /* (AMIROOS_CFG_SSSP_END_START != true) */
 #endif /* (AMIROOS_CFG_SSSP_MSI == true) */
-
-#if (AMIROOS_CFG_SSSP_MSI == true)
-  // module ID is initialized as 'invalid'
-  aos.sssp.moduleId = AOS_SSSP_MODULEID_INVALID;
-#endif /* (AMIROOS_CFG_SSSP_MSI == true) */
+  }
+#endif /* (AMIROOS_CFG_DBG == true) */
 
   // initialize static variables
   _uptime = system_uptime;
@@ -342,25 +476,25 @@ void aosSsspInit(aos_timestamp_t* system_uptime)
   _syncskew = 0.0f;
 #endif /* (AMIROOS_CFG_SSSP_MASTER != true) && (AMIROOS_CFG_PROFILE == true) */
   chVTObjectInit(&_delayTimer);
-  chEvtObjectInit(&_eventSourceDelay);
+  chEvtObjectInit(&_delayEventSource);
 
   // signal interrupt setup
-  palSetLineCallback(moduleSsspGpioPD.gpio->line, aosSysGetStdGpioCallback(), &moduleSsspGpioPD.gpio->line);
-  palEnableLineEvent(moduleSsspGpioPD.gpio->line, APAL2CH_EDGE(moduleSsspGpioPD.meta.edge));
+  palSetLineCallback(moduleSsspSignalPD()->gpio->line, aosSysGetStdGpioCallback(), &moduleSsspSignalPD()->gpio->line);
+  palEnableLineEvent(moduleSsspSignalPD()->gpio->line, APAL2CH_EDGE(moduleSsspSignalPD()->meta.edge));
 #if (AMIROOS_CFG_SSSP_MASTER == true)
-  palSetLineCallback(moduleSsspGpioS.gpio->line, aosSysGetStdGpioCallback(), &moduleSsspGpioS.gpio->line);
+  palSetLineCallback(moduleSsspSignalS()->gpio->line, aosSysGetStdGpioCallback(), &moduleSsspSignalS()->gpio->line);
 #else /* (AMIROOS_CFG_SSSP_MASTER == true) */
-  palSetLineCallback(moduleSsspGpioS.gpio->line, _gpioCallbackSSignal, &moduleSsspGpioS.gpio->line);
+  palSetLineCallback(moduleSsspSignalS()->gpio->line, _gpioCallbackSSignal, &moduleSsspSignalS()->gpio->line);
 #endif /* (AMIROOS_CFG_SSSP_MASTER == true) */
-  palEnableLineEvent(moduleSsspGpioS.gpio->line, APAL2CH_EDGE(moduleSsspGpioS.meta.edge));
+  palEnableLineEvent(moduleSsspSignalS()->gpio->line, APAL2CH_EDGE(moduleSsspSignalS()->meta.edge));
 #if (AMIROOS_CFG_SSSP_MSI == true)
 #if (AMIROOS_CFG_SSSP_STACK_START != true)
-  palSetLineCallback(moduleSsspGpioDN.gpio->line, aosSysGetStdGpioCallback(), &moduleSsspGpioDN.gpio->line);
-  palEnableLineEvent(moduleSsspGpioDN.gpio->line, APAL2CH_EDGE(moduleSsspGpioDN.meta.edge));
+  palSetLineCallback(moduleSsspSignalDN()->gpio->line, aosSysGetStdGpioCallback(), &moduleSsspSignalDN()->gpio->line);
+  palEnableLineEvent(moduleSsspSignalDN()->gpio->line, APAL2CH_EDGE(moduleSsspSignalDN()->meta.edge));
 #endif /* (AMIROOS_CFG_SSSP_STACK_START != true) */
 #if (AMIROOS_CFG_SSSP_STACK_END != true)
-  palSetLineCallback(moduleSsspGpioUP.gpio->line, aosSysGetStdGpioCallback(), &moduleSsspGpioUP.gpio->line);
-  palEnableLineEvent(moduleSsspGpioUP.gpio->line, APAL2CH_EDGE(moduleSsspGpioUP.meta.edge));
+  palSetLineCallback(moduleSsspSignalUP()->gpio->line, aosSysGetStdGpioCallback(), &moduleSsspSignalUP()->gpio->line);
+  palEnableLineEvent(moduleSsspSignalUP()->gpio->line, APAL2CH_EDGE(moduleSsspSignalUP()->meta.edge));
 #endif /* (AMIROOS_CFG_SSSP_STACK_END != true) */
 #endif /* (AMIROOS_CFG_SSSP_MSI == true) */
 
@@ -373,7 +507,6 @@ void aosSsspInit(aos_timestamp_t* system_uptime)
  *          The function aosSsspShutdownInit() must be used instead.
  *
  * @param[in]   listener  An optional listener, in case the system has to wait for a specific event.
- * @param[in]   flags     The relevant flags to wait for (mandatory if a listener is given).
  * @param[in]   mask      If the stage transition involves a timer event (handled internally by this function),
  *                        the given input value of this parameter defines the mask to be used for that event.
  *                        In case a listener was specified, the according mask is retrieved from the listener but this parameter is still used as input for sanity checks.
@@ -381,7 +514,7 @@ void aosSsspInit(aos_timestamp_t* system_uptime)
  *
  * @return  Status, indicating whether proceeding in the protocol was successful.
  */
-aos_status_t aosSsspProceed(event_listener_t* listener, eventflags_t flags, eventmask_t mask, eventmask_t* received)
+aos_status_t aosSsspProceed(event_listener_t* listener, eventmask_t mask, eventmask_t* received)
 {
   // local variables
 #pragma GCC diagnostic push
@@ -402,23 +535,21 @@ aos_status_t aosSsspProceed(event_listener_t* listener, eventflags_t flags, even
     {
 #if (AMIROOS_CFG_SSSP_MASTER == true)
       aosDbgCheck(listener == NULL);
-      aosDbgCheck(flags == 0);
       aosDbgCheck(mask != 0);
       aosDbgCheck(received != NULL);
 
       // delay execution and deactivate the S signal on success
-      if (_delay(AOS_SSSP_DELAY, mask, (laststage != AOS_SSSP_STAGE_STARTUP_1_1), received) == AOS_SUCCESS) {
-        apalControlGpioSet(&moduleSsspGpioS, APAL_GPIO_OFF);
+      if (_delay(AOS_SSSP_DELAY, mask, received) == AOS_SUCCESS) {
+        apalControlGpioSet(moduleSsspSignalS(), APAL_GPIO_OFF);
         nextstage = AOS_SSSP_STAGE_STARTUP_1_2;
       }
 #else /* (AMIROOS_CFG_SSSP_MASTER == true) */
       aosDbgCheck(listener == NULL);
-      aosDbgCheck(flags == 0);
       aosDbgCheck(mask == 0);
       aosDbgCheck(received == NULL);
 
       // deactivate S signal and proceed
-      apalControlGpioSet(&moduleSsspGpioS, APAL_GPIO_OFF);
+      apalControlGpioSet(moduleSsspSignalS(), APAL_GPIO_OFF);
       nextstage = AOS_SSSP_STAGE_STARTUP_1_2;
 #endif /* (AMIROOS_CFG_SSSP_MASTER == true) */
       break;
@@ -430,12 +561,11 @@ aos_status_t aosSsspProceed(event_listener_t* listener, eventflags_t flags, even
     case AOS_SSSP_STAGE_STARTUP_1_2:
     {
       aosDbgCheck(listener != NULL);
-      aosDbgCheck(flags != 0);
       aosDbgCheck(mask == listener->events);
       aosDbgCheck(received != NULL);
 
       // wait for the S signal to become inactive and proceed on success
-      if (_waitForS(listener, flags, APAL_GPIO_OFF, received) == AOS_SUCCESS) {
+      if (_waitForS(listener, APAL_GPIO_OFF, received) == AOS_SUCCESS) {
         nextstage = AOS_SSSP_STAGE_STARTUP_1_3;
       }
       break;
@@ -449,24 +579,22 @@ aos_status_t aosSsspProceed(event_listener_t* listener, eventflags_t flags, even
     {
 #if (AMIROOS_CFG_SSSP_MASTER == true)
       aosDbgCheck(listener == NULL);
-      aosDbgCheck(flags == 0);
       aosDbgCheck(mask != 0);
       aosDbgCheck(received != NULL);
 
       // delay execution and deactivate the S signal on success
-      if (_delay(AOS_SSSP_DELAY, mask, (laststage != AOS_SSSP_STAGE_STARTUP_1_3), received) == AOS_SUCCESS) {
-        apalControlGpioSet(&moduleSsspGpioS, APAL_GPIO_ON);
+      if (_delay(AOS_SSSP_DELAY, mask, received) == AOS_SUCCESS) {
+        apalControlGpioSet(moduleSsspSignalS(), APAL_GPIO_ON);
         nextstage = AOS_SSSP_STAGE_STARTUP_2_1;
       }
 #else /* (AMIROOS_CFG_SSSP_MASTER == true) */
       aosDbgCheck(listener != NULL);
-      aosDbgCheck(flags != 0);
       aosDbgCheck(mask == listener->events);
       aosDbgCheck(received != NULL);
 
       // wait for the S signal to become active and activate it as well and proceed on success
-      if (_waitForS(listener, flags, APAL_GPIO_ON, received) == AOS_SUCCESS) {
-        apalControlGpioSet(&moduleSsspGpioS, APAL_GPIO_ON);
+      if (_waitForS(listener, APAL_GPIO_ON, received) == AOS_SUCCESS) {
+        apalControlGpioSet(moduleSsspSignalS(), APAL_GPIO_ON);
         nextstage = AOS_SSSP_STAGE_STARTUP_2_1;
       }
 #endif /* (AMIROOS_CFG_SSSP_MASTER == true) */
@@ -483,23 +611,23 @@ aos_status_t aosSsspProceed(event_listener_t* listener, eventflags_t flags, even
     {
 #if (AMIROOS_CFG_SSSP_MASTER == true)
       aosDbgCheck(listener == NULL);
-      aosDbgCheck(flags == 0);
       aosDbgCheck(mask != 0);
       aosDbgCheck(received != NULL);
 
       // delay execution and deactivate the S signal on success
-      if (_delay(AOS_SSSP_DELAY, mask, (laststage != AOS_SSSP_STAGE_STARTUP_2_1), received) == AOS_SUCCESS) {
-        apalControlGpioSet(&moduleSsspGpioS, APAL_GPIO_OFF);
+      if (_delay(AOS_SSSP_DELAY, mask, received) == AOS_SUCCESS) {
+        apalControlGpioSet(moduleSsspSignalS(), APAL_GPIO_OFF);
         nextstage = AOS_SSSP_STAGE_STARTUP_2_2;
+      } else {
+        aosprintf(".");
       }
 #else /* (AMIROOS_CFG_SSSP_MASTER == true) */
       aosDbgCheck(listener == NULL);
-      aosDbgCheck(flags == 0);
       aosDbgCheck(mask == 0);
       aosDbgCheck(received == NULL);
 
       // deactivate S signal and proceed
-      apalControlGpioSet(&moduleSsspGpioS, APAL_GPIO_OFF);
+      apalControlGpioSet(moduleSsspSignalS(), APAL_GPIO_OFF);
       nextstage = AOS_SSSP_STAGE_STARTUP_2_2;
       mask = 0;
 #endif /* (AMIROOS_CFG_SSSP_MASTER == true) */
@@ -513,17 +641,16 @@ aos_status_t aosSsspProceed(event_listener_t* listener, eventflags_t flags, even
     case AOS_SSSP_STAGE_STARTUP_2_2:
     {
       aosDbgCheck(listener != NULL);
-      aosDbgCheck(flags != 0);
       aosDbgCheck(mask == listener->events);
       aosDbgCheck(received != NULL);
 
       // wait for the S signal to become inactive and proceed on success
-      if (_waitForS(listener, flags, APAL_GPIO_OFF, received) == AOS_SUCCESS) {
+      if (_waitForS(listener, APAL_GPIO_OFF, received) == AOS_SUCCESS) {
 #if (AMIROOS_CFG_SSSP_MSI == true)
         nextstage = AOS_SSSP_STAGE_STARTUP_3;
 #else /* (AMIROOS_CFG_SSSP_MSI == true) */
-        chSysLock();
         // start the internal uptime aggregation
+        chSysLock();
         aosSysStartUptimeS();
 #if (AMIROOS_CFG_SSSP_MASTER == true)
         // start toggling S for system synchronization
@@ -536,11 +663,10 @@ aos_status_t aosSsspProceed(event_listener_t* listener, eventflags_t flags, even
       break;
     }
 
-#if (AMIROOS_CFG_SSSP_MSI == true)
-
-      //TODO
-
-#endif /* (AMIROOS_CFG_SSSP_MSI == true) */
+    /*
+     * PLEASE NOTE:
+     * Stage transitions during MSI are not hanlded by thins function but are executed in aosSsspMsi().
+     */
 
     /*
      * Invalid operation.
@@ -560,14 +686,13 @@ aos_status_t aosSsspProceed(event_listener_t* listener, eventflags_t flags, even
     case AOS_SSSP_STAGE_SHUTDOWN_1_2:
     {
       aosDbgCheck(listener == NULL);
-      aosDbgCheck(flags == 0);
       aosDbgCheck(mask == 0);
       aosDbgCheck(received == NULL);
 
       // delay execution
       aosThdUSleep(AOS_SSSP_DELAY);
       // deactivate S signal
-      apalControlGpioSet(&moduleSsspGpioS, APAL_GPIO_OFF);
+      apalControlGpioSet(moduleSsspSignalS(), APAL_GPIO_OFF);
       nextstage = AOS_SSSP_STAGE_SHUTDOWN_1_3;
       break;
     }
@@ -580,12 +705,11 @@ aos_status_t aosSsspProceed(event_listener_t* listener, eventflags_t flags, even
     case AOS_SSSP_STAGE_SHUTDOWN_1_3:
     {
       aosDbgCheck(listener != NULL);
-      aosDbgCheck(flags != 0);
       aosDbgCheck(mask == listener->events);
       aosDbgCheck(received != NULL);
 
       // wait for the S signal to become inactive and proceed on success
-      if (_waitForS(listener, flags, APAL_GPIO_OFF, received) == AOS_SUCCESS) {
+      if (_waitForS(listener, APAL_GPIO_OFF, received) == AOS_SUCCESS) {
         nextstage = AOS_SSSP_STAGE_SHUTDOWN_2_1;
       }
       break;
@@ -598,13 +722,12 @@ aos_status_t aosSsspProceed(event_listener_t* listener, eventflags_t flags, even
     case AOS_SSSP_STAGE_SHUTDOWN_2_1:
     {
       aosDbgCheck(listener == NULL);
-      aosDbgCheck(flags == 0);
       aosDbgCheck(mask == 0);
       aosDbgCheck(received != NULL);
 
       // evaluate PD signal
       apalControlGpioState_t pd;
-      apalControlGpioGet(&moduleSsspGpioPD, &pd);
+      apalControlGpioGet(moduleSsspSignalPD(), &pd);
       *received = (pd == APAL_GPIO_ON) ? (eventmask_t)~0 : 0;
       nextstage = AOS_SSSP_STAGE_SHUTDOWN_2_2;
       break;
@@ -616,7 +739,6 @@ aos_status_t aosSsspProceed(event_listener_t* listener, eventflags_t flags, even
     case AOS_SSSP_STAGE_SHUTDOWN_2_2:
     {
       aosDbgCheck(listener == NULL);
-      aosDbgCheck(flags == 0);
       aosDbgCheck(mask == 0);
       aosDbgCheck(received == NULL);
 
